# spec file for Sun Grid Engine 5.3p6 application
#
Summary: Sun Grid Engine (SGE) 5.3p6 Distributed Networked Batch System
Name: sge
Version: 5.3p6
Release: 2
Copyright: Sun Industry Standards Source License 
Group: Applications/System
Source0: sge-V53p6_TAG-src.tar.gz
Source1: SGE53AdminUserDoc.pdf
Source2: SGE53Ref.pdf
Source3: SGEEE53AdminUserDoc.pdf
Source4: qconf_scripts.tar.gz
URL: http://gridengine.sunsource.net
Distribution: Lynx BCC Company
Vendor: Sun Microsystems,Inc.
Packager: Lynx BCC Company <http://www.lynx.ru>

Prefix: /usr/gridengine-%{version}
BuildRoot: /tmp/%{name}-%{version}

%description
Sun Grid Engine 5.3p6 is distributed resource management and job
queuing system. This queuing system optimally assigns jobs to available
and low loaded resources. Aggregates the compute power of servers and desktop
workstations. Analyzes and distributes each available resource,
including CPU, RAM, disk, allowed load, number of permitted jobs,
time of availability, etc. 

#

%prep
%setup -c %{name}-%{version}

%build
cd gridengine/source
#   sed '1119s/set XLIBS    = "-Xlinker -Bstatic -lXm -Xlinker -Bdynamic -lXpm -lXt -lXext -lX11 -lSM -lICE -lXp"/\
#   set XLIBS    = "-lXmu -Xlinker -Bstatic -lXm -Xlinker -Bdynamic -lXpm -lXt -lXext -lX11 -lSM -lICE -lXp"/' \
#   aimk > aimk.tmp
#   mv -f aimk.tmp aimk
#   chmod +x aimk
cp 3rdparty/qtcsh/sh.h 3rdparty/qtcsh/sh.h.tmp
cat 3rdparty/qtcsh/sh.h.tmp | sed -e 's?extern pid_t setpgrp __P((pid_t, pid_t));?/*extern pid_t setpgrp __P((pid_t, pid_t));*/?g' > 3rdparty/qtcsh/sh.h
rm -f 3rdparty/qtcsh/sh.h.tmp

./aimk -only-depend
./scripts/zerodepend
./aimk depend
#./aimk -DHAS_IN_PORT_T
#./aimk -no-qtcsh
#env SGE_INPUT_CFLAGS="-Wno-sign-compare -Wno-strict-aliasing" ./aimk
./aimk
./aimk -man

%install
cd gridengine/source
SGE_ROOT=$RPM_BUILD_ROOT/usr/gridengine-%{version}; export SGE_ROOT 
mkdir -p $SGE_ROOT
chown -R root.root $SGE_ROOT

ln -s scripts/distinst myinst
./myinst -allall glinux
#
cd ../../
tar zxf /usr/src/redhat/SOURCES/qconf_scripts.tar.gz
cd qconf_scripts
cp -a install.sh install.sh.tmp
cat install.sh.tmp | sed 's?ln -s \$install_dir/?ln -s ../../util/?' > install.sh
rm -f install.sh.tmp
./install.sh
cd ..
#
cp /usr/src/redhat/SOURCES/SGE53AdminUserDoc.pdf $SGE_ROOT/doc
cp /usr/src/redhat/SOURCES/SGE53Ref.pdf  $SGE_ROOT/doc
cp /usr/src/redhat/SOURCES/SGEEE53AdminUserDoc.pdf  $SGE_ROOT/doc

ACCOUNT="$SGE_ROOT/util/update_commands/accounting.awk"
if grep '^BEGIN {FS=":"; OFS=":"}' $ACCOUNT > /dev/null
then
   true
   sed '1s/BEGIN {FS=":"; OFS=":"}/#BEGIN {FS=":"; OFS=":"}/' \
   $ACCOUNT > $ACCOUNT.tmp
   mv -f $ACCOUNT.tmp $ACCOUNT
   chmod +x $ACCOUNT
fi


%files
/usr/gridengine-%{version}
%docdir /usr/gridengine-%{version}/man
%docdir /usr/gridengine-%{version}/doc

%clean
cd ..
rm -rf %{name}-%{version}
rm -rf $RPM_BUILD_ROOT

#  script to run after installing SGE 

%post
ACCOUNT="$RPM_INSTALL_PREFIX/util/update_commands/accounting.awk"
if grep '^#BEGIN {FS=":"; OFS=":"}' $ACCOUNT > /dev/null
then
   true
   sed '1s/#BEGIN {FS=":"; OFS=":"}/BEGIN {FS=":"; OFS=":"}/' \
   $ACCOUNT > $ACCOUNT.tmp
   mv -f $ACCOUNT.tmp $ACCOUNT
   chmod +x $ACCOUNT
fi

#if grep "^sge_commd" /etc/services > /dev/null
#then 
#   true
#else
#   echo "sge_commd       1029/tcp                        # Sun  GridEngine" >>\
# /etc/services
#fi

#

if grep "$RPM_INSTALL_PREFIX/lib/glinux" /etc/ld.so.conf > \
  /dev/null
then 
   true
else
   echo "$RPM_INSTALL_PREFIX/lib/glinux/" >> /etc/ld.so.conf
   /sbin/ldconfig
fi



if grep "$RPM_INSTALL_PREFIX/man" /etc/man.config > /dev/null
then
   true
else
   true 
   echo "MANPATH     $RPM_INSTALL_PREFIX/man" >>\
   /etc/man.config
   echo "MANPATH_MAP     \
   $RPM_INSTALL_PREFIX/bin/glinux\
   $RPM_INSTALL_PREFIX/man" >>\
   /etc/man.config
fi
echo "--------------------------------------------------------------"
echo "Sun Grid Engine 5.3p6 has been  installed in "
echo "$RPM_INSTALL_PREFIX directory."
echo "Modification of /etc/ld.so.conf and /etc/man.config"
echo "have been made."
echo "Please read INSTALL and other documents in directory "
echo "$RPM_INSTALL_PREFIX/doc for final installation and"
echo "configuration."
echo "You may install SGE in different place, just specify parameter"
echo "--prefix new_dir in command rpm."
echo "You should set environmental variable SGE_ROOT to  "
echo "$RPM_INSTALL_PREFIX"
echo "--------------------------------------------------------------"


%postun
#  script to run after uninstalling SGE

#if grep "^sge_commd" /etc/services > /dev/null
#then 
#   true
#    grep -v "^sge_commd" /etc/services > /etc/services.tmp
#    mv -f /etc/services.tmp /etc/services
#fi

if grep "$RPM_INSTALL_PREFIX" /etc/man.config > /dev/null
then 
   true
    grep -v "$RPM_INSTALL_PREFIX" /etc/man.config >\
    /etc/man.config.tmp
    mv -f /etc/man.config.tmp /etc/man.config
fi
#
if grep "$RPM_INSTALL_PREFIX/lib/glinux" /etc/ld.so.conf > /dev/null
then 
    true
    grep -v "$RPM_INSTALL_PREFIX/lib/glinux" /etc/ld.so.conf >\
    /etc/ld.so.conf.tmp
    mv -f /etc/ld.so.conf.tmp /etc/ld.so.conf
    /sbin/ldconfig
fi
